unit UnitDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, recolaapi, clipbrd;

type
  TForm1 = class(TForm)
    ButtonClupboard: TButton;
    Label1: TLabel;
    ListBoxZones: TListBox;
    procedure ButtonClupboardClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    LASession:Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 LoadLALibrary;
 LASession:=LA_Init('demo','demo');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 LA_Done(LASession);
 FreeLALibrary;
end;

procedure TForm1.ButtonClupboardClick(Sender: TObject);
 Var DIBHandle:THandle;
     ZonesCount,i:Integer;
     X1,Y1,X2,Y2,Content:Integer;
     ZoneName:Array[0..7] of String;
begin
 ZoneName[0]:='line';
 ZoneName[1]:='table';
 ZoneName[2]:='column inside a table';
 ZoneName[3]:='cell inside a table';
 ZoneName[4]:='inverse text';
 ZoneName[5]:='image';
 ZoneName[6]:='text';
 ZoneName[7]:='noise';

  if Clipboard.HasFormat(cf_DIB) then
   begin
    Clipboard.Open;
    try
     DIBHandle:=Clipboard.GetAsHandle(cf_DIB);

     // Performs processing
     LA_Execute(LASession, DIBHandle);

     // Retrieve the size of the buffer to allocate
     ZonesCount := LA_GetZonesCount(LASession);

     ShowMessage(IntTOStr(ZonesCount)+' zones found !');

     ListBoxZones.Clear;

     // retrieve the result in the buffer
     for i:=0 to ZonesCount-1 do
      begin

       // Retrieve the zone coordinates
       LA_GetZoneRect(LASession,i,X1,Y1,X2,Y2);

       // Retrieve the zone content
       LA_GetZoneContent(LASession,i,Content);

       // Dipsplay the zone info
       ListBoxZones.Items.Add(Format('%d,%d,%d,%d,%s',[X1,Y1,X2,Y2,ZoneName[Content]]));

      end;

    finally
     Clipboard.Close;
    end;
   end
  else ShowMessage('No DIB in clipboard !');
end;

end.
